# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FlavorProfileSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'flavor_mapping': 'dict(str, IaasapiflavorprofilesFlavorMapping)',
        'region_id': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'flavor_mapping': 'flavorMapping',
        'region_id': 'regionId'
    }

    def __init__(self, name=None, description=None, flavor_mapping=None, region_id=None):  # noqa: E501
        """FlavorProfileSpecification - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._flavor_mapping = None
        self._region_id = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.flavor_mapping = flavor_mapping
        self.region_id = region_id

    @property
    def name(self):
        """Gets the name of this FlavorProfileSpecification.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this FlavorProfileSpecification.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FlavorProfileSpecification.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this FlavorProfileSpecification.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this FlavorProfileSpecification.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this FlavorProfileSpecification.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FlavorProfileSpecification.

        A human-friendly description.  # noqa: E501

        :param description: The description of this FlavorProfileSpecification.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def flavor_mapping(self):
        """Gets the flavor_mapping of this FlavorProfileSpecification.  # noqa: E501

        Map between global fabric flavor keys <String> and fabric flavor descriptions <FabricFlavorDescription>   # noqa: E501

        :return: The flavor_mapping of this FlavorProfileSpecification.  # noqa: E501
        :rtype: dict(str, IaasapiflavorprofilesFlavorMapping)
        """
        return self._flavor_mapping

    @flavor_mapping.setter
    def flavor_mapping(self, flavor_mapping):
        """Sets the flavor_mapping of this FlavorProfileSpecification.

        Map between global fabric flavor keys <String> and fabric flavor descriptions <FabricFlavorDescription>   # noqa: E501

        :param flavor_mapping: The flavor_mapping of this FlavorProfileSpecification.  # noqa: E501
        :type: dict(str, IaasapiflavorprofilesFlavorMapping)
        """
        if flavor_mapping is None:
            raise ValueError("Invalid value for `flavor_mapping`, must not be `None`")  # noqa: E501

        self._flavor_mapping = flavor_mapping

    @property
    def region_id(self):
        """Gets the region_id of this FlavorProfileSpecification.  # noqa: E501

        The id of the region for which this profile is created  # noqa: E501

        :return: The region_id of this FlavorProfileSpecification.  # noqa: E501
        :rtype: str
        """
        return self._region_id

    @region_id.setter
    def region_id(self, region_id):
        """Sets the region_id of this FlavorProfileSpecification.

        The id of the region for which this profile is created  # noqa: E501

        :param region_id: The region_id of this FlavorProfileSpecification.  # noqa: E501
        :type: str
        """
        if region_id is None:
            raise ValueError("Invalid value for `region_id`, must not be `None`")  # noqa: E501

        self._region_id = region_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FlavorProfileSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FlavorProfileSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
